'coded by Evan Thoms, U.S. Geological Survey, 2003-2006 
'GDA 1.0

Option Explicit 

'Global variables 
Dim BSX, BSY, BSZ 
Dim g_objPg1Ctls, g_strWhichOffset 
Dim g_strWhichSources 

'*****************TOOLBAR BUTTON EVENTS********************* 
'----------------------------------------------------------- 
Sub EditStations 'OnClick event of btnAddStation 
  Dim strCommand, blnChecked 

  strCommand = Map.Pointermode 
  blnChecked = ThisEvent.Object.Checked 

  If strCommand = "modedrawpolyline" Then 
    Application.ExecuteCommand(strCommand) 
  End If 

  If blnChecked = False Then 'And strCommand <> "modedrawpoint" Then 
    Map.Layers("Stations_1.0").Editable = True 
    Application.Toolbars("GDA").Item("btnAddStation").Checked = True 
    Application.ExecuteCommand("modedrawpoint") 
    Application.Toolbars("GDA").Item("btnAddStation").Checked = True 
    Application.Toolbars("GDA").Item(3).Checked = False 
    Application.Toolbars("GDA").Item("btnDigMylar").Checked = False 
  Else 
    Map.Layers("Stations_1.0").Editable = False 
    Application.Toolbars("GDA").Item("btnAddStation").Checked = False 
    Application.ExecuteCommand("modepan") 
  End If 
End Sub 

'----------------------------------------------------------- 
Sub StationAtGPS 'OnClick event of btnStaAtGPS 
  Toolbars("GDA").Item("btnAddStation").Checked = False 
  Toolbars("GDA").Item(3).Checked = False 
  Toolbars("GDA").Item("btnDigMylar").Checked = False 

  Map.Layers("Stations_1.0").Editable = True 
  Application.ExecuteCommand("addgpspoint") 
End Sub 

'----------------------------------------------------------- 
Sub AddFreeGeoline 'OnClick event of btnFreeGeoline 
  Dim strCommand, btn 

  strCommand = Map.Pointermode 
  Set btn = ThisEvent.Object 

  If strCommand = "modedrawpolyline" Then 
    Application.ExecuteCommand(strCommand) 
  End If 

  If btn.Checked = False Then 
    Map.Layers("Geolines_1.0").Editable = True 
    Application.ExecuteCommand("modedrawfreehandline") 
    Application.Toolbars("GDA").Item("btnAddSta").Checked = False 
    Application.Toolbars("GDA").Item("btnDigMylar").Checked = False 
    btn.Checked = True 
    btn.Item(1).Checked = False 
  Else 
    Map.Layers("Geolines_1.0").Editable = False 
    btn.Checked = False 
    Application.ExecuteCommand("modepan") 
  End If 
End Sub 

'----------------------------------------------------------- 
Sub AddPolyGeoline 'OnClick event of btnPolyGeoline 
  Dim strCommand, btn 

  strCommand = Map.Pointermode 
  Set btn = ThisEvent.Object 

  If strCommand = "modedrawpolyline" Then 
    Application.ExecuteCommand(strCommand) 
  End If 

  If btn.Checked = False Then 
    Map.Layers("Geolines_1.0").Editable = True 
    Application.ExecuteCommand("modedrawpolyline") 
    Application.Toolbars("GDA").Item("btnAddSta").Checked = False 
    Application.Toolbars("GDA").Item("btnStaAtGPS").Checked = False 
    Application.Toolbars("GDA").Item("btnDigMylar").Checked = False 
    btn.Checked = True 
    Application.Toolbars("GDA").Item("btnFreeGeoline").Checked = False 
  Else 
    Map.Layers("Geolines_1.0").Editable = False 
    btn.Checked = False 
    Application.ExecuteCommand("modepan") 
  End If 
End Sub 

'----------------------------------------------------------- 
Sub DigitalMylar 'OnClick event of btnDigMylar 
  Dim strCommand, blnChecked 

  strCommand = Map.Pointermode 
  blnChecked = ThisEvent.Object.Checked 

  If strCommand = "modedrawpolyline" Then 
    Application.ExecuteCommand(strCommand) 
  End If 

  If blnChecked = False And strCommand <> "modedrawfreehandline" Then 
    Map.Layers("Mylar_1.0").Editable = True 
    Application.Toolbars("GDA").Item("btnDigMylar").Checked = True 
    Application.ExecuteCommand("modedrawfreehandline") 
  Else 
    Map.Layers("Mylar_1.0").Editable = True 
  End If 

  If blnChecked = True Then 
    Map.Layers("Mylar_1.0").Editable = False 
    Application.Toolbars("GDA").Item("btnDigMylar").Checked = False 
    Application.ExecuteCommand("modezoomin") 
    Exit Sub 
  End If 
    Application.Toolbars("GDA").Item("btnDigMylar").Checked = True 
    Application.Toolbars("GDA").Item("btnAddSta").Checked = False 
    Application.Toolbars("GDA").Item("btnStaAtGPS").Checked = False 
    Application.Toolbars("GDA").Item(3).Checked = False 
End Sub 

'----------------------------------------------------------- 
Sub GDAHelp 
  Dim fHelpHtm, fHelpPath 
 
  Set fHelpHtm = Application.CreateAppObject("File") 
  fHelpPath = Application.Properties("AppletsPath") & "\GDAhelp\GDAhelp.htm" 
  If fHelpHtm.Exists(fHelpPath) = False Then 
    MsgBox "GDAHelp.htm could not be located. Check that the GDAHelp folder is in the Applets folder" 
    Exit Sub 
  End If 
  Application.Run fHelpPath 
End Sub 

'----------------------------------------------------------- 
Sub StationAsOffset 'Get basestation info and show the offset form 
'OnClick event of btnOffsetSta 
  Dim rsSelSta 

  Set rsSelSta = Map.SelectionLayer.Records 
  rsSelSta.Bookmark = Map.SelectionBookmark 

' Get the info  
  If rsSelSta.Fields("DATUM").IsNull = True Then 
    Application.UserProperties("DATUMID") = rsSelSta.Fields("STAID").Value 
  Else 
    Application.UserProperties("DATUMID") = rsSelSta.Fields("DATUM").Value 
  End If 

  BSX = rsSelSta.Fields.Shape.X 
  BSY = rsSelSta.Fields.Shape.Y 
  BSZ = rsSelSta.Fields.Shape.Z 
  Application.Applets("GDA").Forms("frmOffsetMethod").Show 
End Sub 

'----------------------------------------------------------- 
Sub LoadOffsetForm 'OnLoad event of Offset general form 
  ThisEvent.Object.Caption = Application.UserProperties("DATUMID") 
End Sub 

'----------------------------------------------------------- 
Sub ToggleEditToolbar 'OnClick event of btnToggleEditbar 
  Application.Toolbars("Draw").Visible = Not Application.Toolbars("Draw").Visible 
  Thisevent.Object.Checked = Not ThisEvent.Object.Checked 
End Sub 

'----------------------------------------------------------- 
Sub CheckDrawToolbar 'OnAfterDraw of Map object 
  'MsgBox Application.Toolbars("Draw").Visible 
  If Application.Toolbars("Draw").Visible = False Then 
    'MsgBox 1 
    Application.Toolbars("GDA").Item("btnToggleEditbar").Checked = False 
  Else 
    'MsgBox 2 
    Application.Toolbars("GDA").Item("btnToggleEditbar").Checked = True 
  End If 
End Sub 
  
'***************************OFFSET FORM EVENTS****************************** 
'----------------------------------------------------------- 
Sub InitializePage1 'OnLoad event of Pg1 of Offset Method form. Required simply 
'because setting the readonly properties of the bearing and distance editboxes to True 
'at design time overrides the Enabled = True toggle of the next sub at 
'runtime. sucks. 
  Set g_objPg1Ctls = ThisEvent.Object.Controls 
  g_objPg1Ctls("chkBearing").Value = False 
  g_objPg1Ctls("chkRangefinder").Value = False 
  g_objPg1Ctls("chkRangefinder").Enabled = False 
  g_objPg1Ctls("eboBearing").Enabled = True 
  g_objPg1Ctls("eboBearing").Value = False 
  g_objPg1Ctls("eboDistance").Enabled = True 
  g_objPg1Ctls("eboDistance").Value = False 
  g_strWhichOffset = "" 
End Sub 

'----------------------------------------------------------- 
Sub ToggleOffsetMethodCheckbox 'OnClick event of either chkBearing or chkRangefinder 
  Select Case ThisEvent.Object.Name 
    Case "chkBearing" 
      g_objPg1Ctls("eboBearing").Enabled = True 
      g_objPg1Ctls("eboDistance").Enabled = True 
      g_objPg1Ctls("chkRangefinder").Value = False 
      g_strWhichOffset = "Bearing" 

    Case "chkRangefinder" 
      g_objPg1Ctls("eboBearing").Enabled = False  
      g_objPg1Ctls("eboDistance").Enabled = False 
      g_objPg1Ctls("chkBearing").Value = False 
      g_strWhichOffset = "Rangefinder" 
  End Select 
End Sub 

'----------------------------------------------------------- 
Sub ValidateBearing 'OnValidate event of eboBearing 
  If IsNumeric(ThisEvent.Object.Value) = False Then 
    ThisEvent.Result = False 
    ThisEvent.MessageText = "Bearing is not a number value" 
    Exit Sub 
  End If 

  If Len(ThisEvent.Object.Value) > 3 Then 
    ThisEvent.Result = False 
    ThisEvent.MessageText = "Bearing must be no more than 3 numbers long." 
  End If 
End Sub 

Sub ValidateDistance 'OnValidate event of eboDistance 
  If IsNumeric(ThisEvent.Object.Value) = False Then 
    ThisEvent.Result = False 
    ThisEvent.MessageText = "Distance is not a number value" 
    Exit Sub 
  End If 
End Sub 

'----------------------------------------------------------- 
Sub CancelOffsetStaForm 'OnCancel of Offset station form 
  Application.UserProperties("DATUMID") = "" 
End Sub 

'----------------------------------------------------------- 
Sub PlotOffset 'OnOk event of the Offset method form 
  Select Case g_strWhichOffset 
    Case "" 
    Exit Sub 

  Case "Bearing" 
    Dim intBearing, intDistance 
    intBearing = g_objPg1Ctls("eboBearing").Value 
    intDistance = g_objPg1Ctls("eboDistance").Value 
    Call OffsetByBearing (intBearing, intDistance) 
 
  Case "Rangefinder" 
    Call OffsetByRangefinder 
  End Select 
End Sub 

'----------------------------------------------------------- 
Sub OffsetByBearing (intBearing, intDistance) 'Called from the PlotOffset sub
 Dim objNewPt, intAngle 

  Set objNewPt = Application.CreateAppObject("Point") 
  If ((intBearing = 360 ) Or (intBearing = 0)) Then 
    objNewPt.X = BSX 
    objNewPt.Y = BSY + intDistance 
  End If 

  If ((intBearing > 0 ) And (intBearing < 90 )) Then 
    intAngle = (90 - intBearing) * (3.1415926535897932/180) 
    objNewPt.X = BSX + (Cos(intAngle) * intDistance) 
    objNewPt.Y = BSY + (Sin(intAngle) * intDistance) 
  End If 

  If (intBearing = 90 ) Then 
    objNewPt.X = BSX + intDistance 
    objNewPt.Y = BSY 
  End If 

  If ((intBearing > 90 ) And (intBearing < 180 )) Then 
    intAngle = (intBearing - 90) * (3.1415926535897932/180) 
    objNewPt.X = BSX + (Cos(intAngle) * intDistance) 
    objNewPt.Y = BSY - (Sin(intAngle) * intDistance) 
  End If 

  If (intBearing = 180 ) Then 
    objNewPt.X = BSX 
    objNewPt.Y = BSY - intDistance 
  End If 

  If ((intBearing > 180 ) And (intBearing < 270 )) Then 
    intAngle = (270 - intBearing) * (3.1415926535897932/180) 
    objNewPt.X = BSX - ( Cos(intAngle) * intDistance) 
    objNewPt.Y = BSY - (Sin(intAngle) * intDistance) 
  End If 

  If (intBearing = 270) Then 
    objNewPt.X = BSX - intDistance 
    objNewPt.Y = BSY 
  End If 
 
  If ((intBearing > 270 ) And (intBearing < 360 )) Then 
    intAngle = (intBearing - 270) * (3.1415926535897932/180) 
    objNewPt.X = BSX - (Cos(intAngle) * intDistance) 
    objNewPt.Y = BSY + (Sin(intAngle) * intDistance) 
  End If 

  Application.ExecuteCommand("clearselected") 
  Application.UserProperties("OffsetLocation") = "Offset" 
  Call Map.AddFeature(objNewPt, True) 
End Sub 


'*********************UTILITY FUNCTIONS************************* 
'----------------------------------------------------------- 
Function GetMonthDay 
  Dim dtDate 
  Dim intY, intM, intD 

  dtDate = FormatDateTime(Now, vbShortDate) 
  intY = Right(Year(dtDate), 2) 
  intM = Month(dtDate) 
  intD = Day(dtDate) 

  If Len(intM) = 1 Then 
    intM = "0" & intM 
  End If 

  If Len(intD) = 1 Then 
    intD = "0" & intD 
  End If 
  GetMonthDay = intM & intD & "_" & intY 
End Function